#!/usr/bin/env python3
#
#

import os
import sys

if sys.version_info.major < 3: print("you need to run BARD with python3") ; os._exit(1)

try: use_setuptools()
except: pass

try:
    from setuptools import setup
except Exception as ex: print(str(ex)) ; os._exit(1)

from distutils import sysconfig
site_packages_path = sysconfig.get_python_lib()

setup(
    name='wet',
    version='1',
    url='https://pikacode.com/bthate/wet',
    author='Bart Thate',
    author_email='bthate@dds.nl',
    description='WET - Respect voor de Schepping.',
    license='MIT',
    include_package_data=True,
    zip_safe=False,
    install_requires=["beautifulsoup4", "sleekxmpp", "feedparser"],
    scripts=["bin/wet", "bin/wet-local", "bin/wet-docs", "bin/wet-udp"],
    packages=['wet',
              'wet.bots',
              'wet.contrib',
              'wet.plugs',
              'wet.services',
             ],
    long_description = """ WET - Respect voor de schepping XMPP - IRC - CLI - RSS - UDP - API  """,
    classifiers=[
        'Development Status :: 4 - Beta',
        'License :: OSI Approved :: MIT License',
        'Operating System :: Unix',
        'Programming Language :: Python',
        'Topic :: Software Development :: Libraries :: Python Modules'],
)
