# wet/bot.py
#
#

""" basic package for the program. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from wet.utils import get_name, short_date, get_type
from wet.errors import RemoteDisconnect
from wet.dispatcher import DISPATCHER
from wet.defines import BLA, ENDC
from wet.object import Object
from wet.runtime import kernel, fleet

import logging
import socket
import time

## BOTS

class BOT(DISPATCHER):

    """ Base Bot class. """

    def __init__(zelf, *args, **kwargs):
        DISPATCHER.__init__(zelf, *args, **kwargs)
        zelf._start = time.time()
        zelf.channels = ["#wet", ]
        
    def say(zelf, *args, **kwargs): print(args[1])
        
    ## CHANNELS

    def announce(zelf, *args, **kwargs):
        """ announce on channels. """
        logging.info("# announce %s" % " ".join(zelf.channels))
        for channel in zelf.channels: zelf.say(channel, args[0])

    def join(zelf, *args, **kwargs): pass
        
    def join_channels(zelf, *args, **kwargs):
        """ join channels.  """ 
        for channel in zelf.channels: zelf.join(channel)
            
## TESTBOT

class TESTBOT(BOT):

    """ USE WITH Bot.put() and Bot.read(). """

    testing = True

    def say(zelf, *args, **kwargs): logging.warn(args[1])

    def event(zelf, *args, **kwargs):
        o = Object()
        o.origin = "test@wet"
        o._target = zelf
        o.loglevel = "warning"
        return o

