# wet/plugs/uptime.py
#
#

""" uptime of services. """

## IMPORTS

from wet.utils import elapsed_days, str_day, error, get_name
from wet.runtime import kernel

import threading
import time

## UNTIL

def until(obj): 
    try: return elapsed_days(int(obj.sleep) - int(time.time() - obj._last))
    except: error() ; return ""

def upt(obj):
    try: return elapsed_days(int(time.time()) - int(obj._start))
    except: return ""

def waiting(obj):
    if sleeptime(obj): return "%s/%s" % (until(obj), sleeptime(obj))
    else: return ""

def idle(obj):
    try: return elapsed_days(int(obj._last - obj._start))
    except: return ""

def status(obj):
    try: return obj._status 
    except: return ""

def name(obj):
    try: return obj._name
    except: return ""

def running(obj):
    try: return obj._running
    except: return ""

def sleeptime(obj):
    try: return elapsed_days(obj.sleep)
    except: return ""

def plugname(obj):
    try: return obj.plugname
    except: return ""

funcs = [status, upt, waiting]

## CMNDS

def uptime(event):
    threads = [x for x in threading.enumerate() if running(x)]
    for obj in sorted(threads,key=running):
        if not running(obj): continue
        try: o = obj._func.__self__
        except: o = obj
        res = "%s: " % running(obj)
        for func in funcs:
            a = func(o)
            if not a: continue
            try: res += "%s " % a
            except: error()
        event.reply(res)
 
kernel.register("uptime", uptime)
